#include <afxwin.h>
#include "resource.h"
#include "..\include\fontlib.h"
#include "windemo.h"


extern struct text TextStruct;
extern  struct TextStyle Normal;
extern char *BufferFonts;             
extern size_t FontFileLength;
extern struct primitivefile Display[];
TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */

//------------------------------------------------------------------------
CTextDlg::CTextDlg(UINT Id): CModalDialog(Id)
{

   String="The quick brown fox jumps over the lazy dog";
   
   Pt1.x=50.0;
   Pt1.y=50.0;
   Pt2.x=400.0;   
   Pt2.y=200.0;
   
   Justification=DEFAULT;  // LEFT 
   Heigth=20.0;
   Angle=0.0;                       
}

//------------------------------------------------------------------------
BOOL CTextDlg::OnInitDialog(void)
{                                               
char Buffer[100];

Buffer[0]=0;

CheckDlgButton(IDC_LEFT,1);
CheckDlgButton(IDC_HORIZONTAL,1);


((CEdit *)GetDlgItem(IDC_TEXTSTRING))->Clear();
((CEdit *)GetDlgItem(IDC_XPOINT))->Clear();
((CEdit *)GetDlgItem(IDC_YPOINT))->Clear();
((CEdit *)GetDlgItem(IDC_X1POINT))->Clear();
((CEdit *)GetDlgItem(IDC_Y1POINT))->Clear();
((CEdit *)GetDlgItem(IDC_HEIGTH))->Clear();
((CEdit *)GetDlgItem(IDC_ANGLE))->Clear();

((CEdit *)GetDlgItem(IDC_TEXTSTRING))->ReplaceSel(String);
((CEdit *)GetDlgItem(IDC_XPOINT))->ReplaceSel(_gcvt(Pt1.x,3,Buffer));
((CEdit *)GetDlgItem(IDC_YPOINT))->ReplaceSel(_gcvt(Pt1.y,3,Buffer));
((CEdit *)GetDlgItem(IDC_X1POINT))->ReplaceSel(_gcvt(Pt2.x,3,Buffer));
((CEdit *)GetDlgItem(IDC_Y1POINT))->ReplaceSel(_gcvt(Pt2.y,3,Buffer));
((CEdit *)GetDlgItem(IDC_HEIGTH))->ReplaceSel(_gcvt(Heigth,3,Buffer));
((CEdit *)GetDlgItem(IDC_ANGLE))->ReplaceSel(_gcvt(Angle,3,Buffer));

switch(Justification)
       {
       case DEFAULT:
            CheckDlgButton(IDC_LEFT,1);
            
            CheckDlgButton(IDC_RIGHT,0);
            CheckDlgButton(IDC_CENTERED,0);
            CheckDlgButton(IDC_FITTED,0);
            
            ((CEdit *)GetDlgItem(IDC_X1POINT))->EnableWindow(FALSE);
            ((CEdit *)GetDlgItem(IDC_Y1POINT))->EnableWindow(FALSE);

            break;
       case RIGHT:
            CheckDlgButton(IDC_RIGHT,1);
            
            CheckDlgButton(IDC_LEFT,0);
            CheckDlgButton(IDC_CENTERED,0);
            CheckDlgButton(IDC_FITTED,0);
            break;
       case CENTERED:
            CheckDlgButton(IDC_CENTERED,1);
            
            CheckDlgButton(IDC_RIGHT,0);
            CheckDlgButton(IDC_LEFT,0);    
            CheckDlgButton(IDC_FITTED,0);
            break;
       case FIT:
            CheckDlgButton(IDC_FITTED,1);
            
            CheckDlgButton(IDC_RIGHT,0);
            CheckDlgButton(IDC_LEFT,0);
            CheckDlgButton(IDC_CENTERED,0);
            
       }


switch(Normal.Orient)
       {
       case HORIZONTAL:
            CheckDlgButton(IDC_HORIZONTAL,1);
            CheckDlgButton(IDC_VERTICAL,0);
            break;
       case VERTICAL:
            CheckDlgButton(IDC_HORIZONTAL,0);
            CheckDlgButton(IDC_VERTICAL,1);
            break;                       
       }     
              

return(TRUE);
}
//--------------------------------------------------------------------------

afx_msg void CTextDlg::OnFittedClick(void)
{
Justification=FIT;

((CEdit *)GetDlgItem(IDC_X1POINT))->EnableWindow(TRUE);
((CEdit *)GetDlgItem(IDC_Y1POINT))->EnableWindow(TRUE);

((CEdit *)GetDlgItem(IDC_HORIZONTAL))->EnableWindow(FALSE);
((CEdit *)GetDlgItem(IDC_VERTICAL))->EnableWindow(FALSE);


}
//------------------------------------------------------------------------
afx_msg void CTextDlg::OnLeftClick(void)
{
Justification=DEFAULT;

((CEdit *)GetDlgItem(IDC_HORIZONTAL))->EnableWindow(TRUE);
((CEdit *)GetDlgItem(IDC_VERTICAL))->EnableWindow(TRUE);


((CEdit *)GetDlgItem(IDC_X1POINT))->EnableWindow(FALSE);
((CEdit *)GetDlgItem(IDC_Y1POINT))->EnableWindow(FALSE);

}
//------------------------------------------------------------------------
afx_msg void CTextDlg::OnRightClick(void)
{
Justification=RIGHT;
Normal.Orient=HORIZONTAL;


((CEdit *)GetDlgItem(IDC_HORIZONTAL))->EnableWindow(TRUE);
((CEdit *)GetDlgItem(IDC_VERTICAL))->EnableWindow(TRUE);

((CEdit *)GetDlgItem(IDC_X1POINT))->EnableWindow(FALSE);
((CEdit *)GetDlgItem(IDC_Y1POINT))->EnableWindow(FALSE);

}
//------------------------------------------------------------------------
afx_msg void CTextDlg::OnCenteredClick(void)
{
Justification=CENTERED;

((CEdit *)GetDlgItem(IDC_HORIZONTAL))->EnableWindow(TRUE);
((CEdit *)GetDlgItem(IDC_VERTICAL))->EnableWindow(TRUE);


((CEdit *)GetDlgItem(IDC_X1POINT))->EnableWindow(FALSE);
((CEdit *)GetDlgItem(IDC_Y1POINT))->EnableWindow(FALSE);

}
//------------------------------------------------------------------------

afx_msg void CTextDlg::OnHorizontalClick(void)
{
Normal.Orient=HORIZONTAL;
InitStyle(Normal,BufferFonts,FontFileLength); // we have to load the font again
}
//------------------------------------------------------------------------
afx_msg void CTextDlg::OnVerticalClick(void)
{
Normal.Orient=VERTICAL;
InitStyle(Normal,BufferFonts,FontFileLength); // we have to load the font again
}
//------------------------------------------------------------------------
afx_msg void CTextDlg::OnTOk(void)  // Ok wass pressed 
{                                                       
#define DisplayIndex (OuttextState.LastPrimitiveIndex)

CString TemporalString;
int Length=0;

GetDlgItem(IDC_TEXTSTRING)->GetWindowText(String);

GetDlgItem(IDC_XPOINT)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Pt1.x=atof(TemporalString.GetBuffer(Length));


GetDlgItem(IDC_YPOINT)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Pt1.y=atof(TemporalString.GetBuffer(Length));

GetDlgItem(IDC_X1POINT)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Pt2.x=atof(TemporalString.GetBuffer(Length));


GetDlgItem(IDC_Y1POINT)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Pt2.y=atof(TemporalString.GetBuffer(Length));

GetDlgItem(IDC_HEIGTH)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Heigth=atof(TemporalString.GetBuffer(Length));


GetDlgItem(IDC_ANGLE)->GetWindowText(TemporalString);
Length=TemporalString.GetLength(); 
Angle=atof(TemporalString.GetBuffer(Length));
TemporalString.ReleaseBuffer(Length);             


String.GetLength(); 
                  
TextStruct.String          =String; 
TextStruct.Justification   =Justification;
TextStruct.Pt1.x           =Pt1.x; 
TextStruct.Pt1.y           =Pt1.y;
TextStruct.Pt2.x           =Pt2.x; 
TextStruct.Pt2.y           =Pt2.y;
TextStruct.Heigth          =Heigth;
TextStruct.Angle           =Angle;


String.ReleaseBuffer(Length);

CModalDialog::OnOK();
}
//------------------------------------------------------------------------
BEGIN_MESSAGE_MAP (CTextDlg  ,CModalDialog)
   ON_COMMAND (IDC_LEFT      ,OnLeftClick) 
   ON_COMMAND (IDC_RIGHT     ,OnRightClick)
   ON_COMMAND (IDC_CENTERED  ,OnCenteredClick)
   ON_COMMAND (IDC_FITTED    ,OnFittedClick)
   ON_COMMAND (IDC_HORIZONTAL,OnHorizontalClick)
   ON_COMMAND (IDC_VERTICAL  ,OnVerticalClick)
   ON_COMMAND (ID_TOK        ,OnTOk)
   
END_MESSAGE_MAP ()
//------------------------------------------------------------------------
