/* Demo example Fonts to dxf file, loadable by Autocad */




#include "stdlib.h"
#include "stdio.h"
#include "conio.h"
#include "graph.h"
#include "dos.h"

#include "..\include\fontlib.h"

struct TextStyle Normal={ "Normal",          /* definition of Style */      
                          "classic4.fnt",     /* definition of the font file */      
                           0.0,              /* heigth         RESERVED */   
                           1.0,              /* with           RESERVED */   
                           0.0,              /* Obiquing angle RESERVED */   
                           FALSE,            /* BackWard       RESERVED */   
                           FALSE,            /* UpsideDown     RESERVED */   
                           HORIZONTAL};      /* initialized to HORIZONTAL */


void InitTextMode(void); 
int  tg_getmaxy(void); 
void InitGraphics(void); 
void PutDisplay(FILE *dxf);
int FontFileExists(char *FontFile);
size_t FontFileSize(char *FontFile);

/*--------------------------------------------------------------------*/
void IniDxfFile(FILE *fp);
void EndDxfFile(FILE *fp);
void DXFLine(FILE *fp, char * layer , double x , double y ,double z,double x1 , double y1 ,double z1);



#define MAX_NUM_PRIMITIVES_FILE 2000
struct primitivefile Display[MAX_NUM_PRIMITIVES_FILE];

TEXTOUPUTSTATE  OuttextState;  /* structure returned by Text() function */
#define DisplayIndex (OuttextState.LastPrimitiveIndex)

char * BufferFonts;

/*--------------------------------------------------------------------------*/
void main(void);
void main(void)
{ 
size_t FontFileLength;
FILE *fp;
FILE *dxf;

/* loading default font file */
    
if(FontFileExists(Normal.FontFile))               /* see if its on disk */       
  FontFileLength=FontFileSize(Normal.FontFile);   /* get the size */
else
  {
  cputs("font file classic4.fnt does not exist\r\n");
  exit(0);  
  }
      
/* get some memory for the buffer that will hold the font file */
if((BufferFonts=( char *) calloc(sizeof( char),(size_t)FontFileLength))==NULL)
  {
  cputs("NO Memory in text for bufferfonts \r\r\n");
  exit(0);
  }
     
      
/* Initializing the font file, this function loads the font file,
  builds a internal table with each font, so execution is faster */
      
   
UserSetPF(Display , MAX_NUM_PRIMITIVES_FILE);   
   
if(InitStyle(Normal,BufferFonts,FontFileLength)!=OK)
 {   
 cputs("\r\nImpossible to Open Font File or Not Enough Memory");
 exit(1);
 }               
     
 InitGraphics(); /* graphic initialization */
 
 
 if((fp=fopen("dxffile.txt","r"))!=NULL)
    {
    char Buffer[255];
    int XPos=10;
    double Heigth=10.0;
    double Angle=0.0;
    RW_POINT Pt1;
    RW_POINT Pt2;

    
    Pt1.x=XPos;
    Pt1.y=300;
   
   
   if((dxf=fopen("dxffile.dxf","w"))!=NULL)
     {       
     IniDxfFile(dxf); /* Start Entities section */
     
     
    
    while(!feof(fp)) /* while end of file not reached */
         {
         
         if((fgets(Buffer,255,fp))!=NULL)
           {                               
           printf("Writing .dxf :%s",Buffer);
           /* Buffer has a \n at the end */
           OuttextState=Text(
             Buffer,               /* string to output */
             DEFAULT,              /* the justification is in the header */
             Pt1,                  /* first point */
             Pt2,                  /* second point */
             Heigth,               /* Heigth of the font */
             Angle*(3.1415/180.0), /* Angle to rotate (Radians)*/
             BufferFonts );        /* The Buffer where the font is loaded */
          
           PutDisplay(dxf); /* display the string */
           
           /* after the string has been displayed the \n works as a line feed
              at the end makes the Y position point to the next line, but
              the x value must be set again to the initial x value
              */
           
          
           /* Pt1.x does not change, it keeps the initial value */
           Pt1.y=OuttextState.LastPt.y;
           }
         }  
    }
    else
        {
        cputs("Cant open the dxffile.dxf\r\n");
        exit(0);
        }
    EndDxfFile(dxf); /* End Entities section */
    fclose(dxf);
   } 
    else
        cputs("Cant open dxffile.txt from disk\r\n");
        
fclose(fp);
        
}                        
#define WHITE 15
/*-----------------------------------------------------------------------*/
void PutDisplay(FILE *dxf);
void PutDisplay(FILE *dxf)
{
   unsigned long i=0;
   int y=tg_getmaxy();
   
   double Lastx=0.0,Lasty=0.0;
   int MovetoFlag=FALSE;
   
   
    
   /* Trace from the first element in the table (0) to the last one (defined)
      in the extern variable DisplayIndex, DisplayIndex is updated wen the Text()
      function is called 
    */  
   for(i=0;i<DisplayIndex;i++)   
      {
       if(Display[i].OpCode==PFMOVETO)   
         {
         Lastx=(double)Display[i].x;
         Lasty=(double)Display[i].y;
         MovetoFlag=TRUE;
         }
      else                              /* Display[i].OpCode==PFLINETO */
          {
          if(MovetoFlag==TRUE)
            {
             DXFLine(dxf,"0",(double)Lastx,(double)Lasty,(double)0.0,(double)Display[i].x,(double)Display[i].y,(double)0.0);
             Lastx=(double)Display[i].x;
             Lasty=(double)Display[i].y;
             MovetoFlag=FALSE;
             }                
            else  /* the last op was a line */
               {                           
               DXFLine(dxf,"0",(double)Lastx,(double)Lasty,(double)0.0,(double)Display[i].x,(double)Display[i].y,(double)0.0);
               Lastx=(double)Display[i].x;
               Lasty=(double)Display[i].y;
               MovetoFlag=FALSE;
               }
          }
      }        
      
   
     
}                    
/*---------------------------------------------------------------------*/
void InitTextMode(void);  /* go back to text mode */
void InitTextMode(void)
{
  _setvideomode(_DEFAULTMODE);
}
/*---------------------------------------------------------------------*/
/* Returns the max number of pixels in y cood */
int tg_getmaxy(void); 
int tg_getmaxy(void)
{                
struct videoconfig config;

  _getvideoconfig(&config);
   return(config.numypixels);
}

/*---------------------------------------------------------------------*/
void InitGraphics(void); /* begin graphic mode */
void InitGraphics(void)
{                
  _settextcolor(7);
  _settextposition(1,1);
  _clearscreen(_GCLEARSCREEN);
  /*  
  if (_setvideomode(_VRES16COLOR))
   return;
  */ 
   
  if (_setvideomode(_ERESCOLOR))
   return;
  
  cputs("This demo program  only runs in VGA or EGA Display\r\n");
  exit(0);
}
/*---------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
int FontFileExists(char *FontFile);
int FontFileExists(char *FontFile)
{
struct find_t Buffer;
return(!_dos_findfirst(FontFile,_A_NORMAL,&Buffer));
}

/*-------------------------------------------------------*/
size_t FontFileSize(char *FontFile);
size_t FontFileSize(char *FontFile)
{
struct find_t Buffer;
_dos_findfirst(FontFile,_A_NORMAL,&Buffer);
return((size_t)Buffer.size);
}
/*------------------------------------------------------------------------*/

/*--------------------------------------------------------------------*/
void IniDxfFile(FILE *fp) /* Start Entities section */
{
fprintf(fp,"  0\nSECTION\n  2\nENTITIES\n");
}
/*--------------------------------------------------------------------*/
void EndDxfFile(FILE *fp) /* End Entities section */
{
fprintf(fp,"  0\nENDSEC\n  0\nEOF\n");
}
/*--------------------------------------------------------------------*/
/* Dxf line */
void DXFLine(FILE *fp, char * layer , double x , double y ,double z,double x1 , double y1 ,double z1)
{
fprintf(fp,"  0\nLINE\n  8\n%s\n 10\n%f\n 20\n%f\n 30\n%f\n 11\n%f\n 21\n%f\n 31\n%f\n", layer,x,y,z,x1,y1,z1);
}
/*--------------------------------------------------------------------*/




